package aufgabe1;

import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.CyclicBarrier;

public class BrokenCyclicLatch {
	private static final int NOF_ROUNDS = 10;
	private static final int NOF_THREADS = 10;

	private static CyclicBarrier latch1 = new CyclicBarrier(NOF_THREADS);
	private static CyclicBarrier latch2 = new CyclicBarrier(NOF_THREADS);

	private static void multiRounds(int threadId) throws InterruptedException, BrokenBarrierException {
		for (int round = 0; round < NOF_ROUNDS; round++) {
			if (round % 2 == 0) {
				latch1.await();
				if (threadId == 0)
					latch1.reset();
			} else {
				latch2.await();
				if (threadId == 0)
					latch2.reset();
			}
			System.out.println("Round " + round + " thread " + threadId);
		}
	}

	public static void main(String[] args) {
		for (int i = 0; i < NOF_THREADS; i++) {
			final int threadId = i;
			new Thread() {
				@Override
				public void run() {
					try {
						multiRounds(threadId);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}.start();
			// new Thread(() -> {
			// try {
			// multiRounds(threadId);
			// } catch (Exception e) {
			// e.printStackTrace();
			// }
			// }).start();
		}
	}
}
