package aufgabe3b;

public class UpgradeableReadWriteLock {
	private int readLocks = 0;
	private int upgradeableReadLocks = 0;
	private int writeLocks = 0;

	public synchronized void readLock() throws InterruptedException {
		while (writeLocks > 0)
			wait();
		++readLocks;
	}

	public synchronized void readUnlock() {
		--readLocks;
		notifyAll();
	}

	public synchronized void upgradeableReadLock() throws InterruptedException {
		while (upgradeableReadLocks > 0 || writeLocks > 0)
			wait();
		++upgradeableReadLocks;
	}

	public synchronized void upgradeableReadUnlock() {
		--upgradeableReadLocks;
		notifyAll();
	}

	public synchronized void writeLock() throws InterruptedException {
		while (readLocks > 0 || upgradeableReadLocks > 0 || writeLocks > 0)
			wait();
		++writeLocks;
	}

	public synchronized void writeUnlock() {
		--writeLocks;
		notifyAll();
	}
}
