package aufgabe2;

import java.util.concurrent.atomic.AtomicInteger;

public class BankAccount {
	private AtomicInteger balance = new AtomicInteger(0);

	public void deposit(int amount) {
		balance.getAndAdd(amount);
	}

	public boolean withdraw(int amount) {
		int oldValue;
		int newValue;
		do {
			oldValue =  balance.get();
			if (amount <= oldValue)
				newValue = oldValue - amount;
			else
				return false;
		} while (!balance.compareAndSet(oldValue, newValue));
		return true;
	}

	public int getBalance() {
		return balance.get();
	}
}
