package aufgabe3;

import java.util.concurrent.atomic.AtomicReference;

// TODO: Implement lock-free stack
public class LockFreeStack<T> implements Stack<T> {
	// TODO: Design stack node class
	class Node<E> {
		E value;
		Node<E> next;

		Node(E value) {
			this.value = value;
		}

		void setNext(Node<E> next) {
			this.next = next;
		}

		Node<E> getNext() {
			return next;
		}

		E getValue() {
			return value;
		}
	}

	// Top Of Stack; nur atomarer Zugriff.
	AtomicReference<Node<T>> top = new AtomicReference<>();

	public void push(T value) {
		// TODO: Implement lock-free push operation
		Node<T> newNode = new Node<>(value);
		Node<T> current;
		boolean success;
		do {
			current = top.get();
			newNode.setNext(current);
			success = top.compareAndSet(current, newNode);
			if (!success)
				Thread.yield();
		} while (!success);
	}

	public T top() { // War nicht gefragt
		return top.get().getValue();
	}

	public T pop() {
		// TODO: Implement lock-free push operation
		Node<T> current;
		Node<T> newtop;
		boolean success;
		do {
			current = top.get();
			if (current == null)
				return null;
			newtop = current.getNext();
			success = top.compareAndSet(current, newtop);
			if (! success)
				Thread.yield();
		} while (!success);
		return current.getValue();
	}
}